/**
 * <copyright>
 * </copyright>
 *
 * $Id: AnzeigeQuerschnittModelNetzTypAbstractImpl.java,v 1.1 2012/12/21 10:45:57 Pittner Exp $
 */
package de.bsvrz.buv.plugin.anlagendarstellung.impl;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EclipsePackage;
import com.bitctrl.lib.eclipse.emf.eclipse.model.Named;

import com.bitctrl.lib.eclipse.emf.gef.model.GefPackage;
import com.bitctrl.lib.eclipse.emf.gef.model.Located;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeQuerschnittModelNetzTypAbstract;

import de.bsvrz.buv.plugin.dobj.model.DoKomponente;
import de.bsvrz.buv.plugin.dobj.model.DoModel;
import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.buv.plugin.dobj.model.DobjPackage;

import de.bsvrz.buv.plugin.dobj.model.impl.DoKomponenteImpl;

import de.bsvrz.dav.daf.main.config.SystemObject;

import java.util.Collection;

import org.eclipse.draw2d.geometry.Point;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Anzeige Querschnitt Model Netz Typ Abstract</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getKomponenten <em>Komponenten</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getDoTyp <em>Do Typ</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getSystemObject <em>System Object</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getRelativZu <em>Relativ Zu</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getAbsoluteLocation <em>Absolute Location</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getBezeichnung <em>Bezeichnung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getKontext <em>Kontext</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getFahrtrichtung <em>Fahrtrichtung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getDataUpdate <em>Data Update</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelNetzTypAbstractImpl#getDarstellungUpdate <em>Darstellung Update</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AnzeigeQuerschnittModelNetzTypAbstractImpl extends DoKomponenteImpl implements AnzeigeQuerschnittModelNetzTypAbstract
{
  /**
   * The cached value of the '{@link #getKomponenten() <em>Komponenten</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKomponenten()
   * @generated
   * @ordered
   */
  protected EList<AnzeigeModelTypAbstract> komponenten;

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getLocation() <em>Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLocation()
   * @generated
   * @ordered
   */
  protected static final Point LOCATION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLocation() <em>Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLocation()
   * @generated
   * @ordered
   */
  protected Point location = LOCATION_EDEFAULT;

  /**
   * The cached value of the '{@link #getDoTyp() <em>Do Typ</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDoTyp()
   * @generated
   * @ordered
   */
  protected DoTyp doTyp;

  /**
   * The default value of the '{@link #getSystemObject() <em>System Object</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSystemObject()
   * @generated
   * @ordered
   */
  protected static final SystemObject SYSTEM_OBJECT_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSystemObject() <em>System Object</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSystemObject()
   * @generated
   * @ordered
   */
  protected SystemObject systemObject = SYSTEM_OBJECT_EDEFAULT;

  /**
   * The cached value of the '{@link #getRelativZu() <em>Relativ Zu</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRelativZu()
   * @generated
   * @ordered
   */
  protected DoModel relativZu;

  /**
   * The default value of the '{@link #getAbsoluteLocation() <em>Absolute Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAbsoluteLocation()
   * @generated
   * @ordered
   */
  protected static final Point ABSOLUTE_LOCATION_EDEFAULT = null;

  /**
   * The default value of the '{@link #getBezeichnung() <em>Bezeichnung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBezeichnung()
   * @generated
   * @ordered
   */
  protected static final String BEZEICHNUNG_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getBezeichnung() <em>Bezeichnung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBezeichnung()
   * @generated
   * @ordered
   */
  protected String bezeichnung = BEZEICHNUNG_EDEFAULT;

  /**
   * The default value of the '{@link #getKontext() <em>Kontext</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKontext()
   * @generated
   * @ordered
   */
  protected static final int KONTEXT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getKontext() <em>Kontext</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKontext()
   * @generated
   * @ordered
   */
  protected int kontext = KONTEXT_EDEFAULT;

  /**
   * The default value of the '{@link #getFahrtrichtung() <em>Fahrtrichtung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFahrtrichtung()
   * @generated
   * @ordered
   */
  protected static final int FAHRTRICHTUNG_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getFahrtrichtung() <em>Fahrtrichtung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFahrtrichtung()
   * @generated
   * @ordered
   */
  protected int fahrtrichtung = FAHRTRICHTUNG_EDEFAULT;

  /**
   * The default value of the '{@link #getDataUpdate() <em>Data Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDataUpdate()
   * @generated
   * @ordered
   */
  protected static final Object DATA_UPDATE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDataUpdate() <em>Data Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDataUpdate()
   * @generated
   * @ordered
   */
  protected Object dataUpdate = DATA_UPDATE_EDEFAULT;

  /**
   * The default value of the '{@link #getDarstellungUpdate() <em>Darstellung Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDarstellungUpdate()
   * @generated
   * @ordered
   */
  protected static final Object DARSTELLUNG_UPDATE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDarstellungUpdate() <em>Darstellung Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDarstellungUpdate()
   * @generated
   * @ordered
   */
  protected Object darstellungUpdate = DARSTELLUNG_UPDATE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnzeigeQuerschnittModelNetzTypAbstractImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AnzeigeModelTypAbstract> getKomponenten()
  {
    if (komponenten == null)
    {
      komponenten = new EObjectContainmentEList<AnzeigeModelTypAbstract>(DoKomponente.class, this, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN);
    }
    return komponenten;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Point getLocation()
  {
    return location;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLocation(Point newLocation)
  {
    Point oldLocation = location;
    location = newLocation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION, oldLocation, location));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoTyp getDoTyp()
  {
    if (doTyp != null && doTyp.eIsProxy())
    {
      InternalEObject oldDoTyp = (InternalEObject)doTyp;
      doTyp = (DoTyp)eResolveProxy(oldDoTyp);
      if (doTyp != oldDoTyp)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP, oldDoTyp, doTyp));
      }
    }
    return doTyp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoTyp basicGetDoTyp()
  {
    return doTyp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDoTyp(DoTyp newDoTyp)
  {
    DoTyp oldDoTyp = doTyp;
    doTyp = newDoTyp;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP, oldDoTyp, doTyp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SystemObject getSystemObject()
  {
    return systemObject;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSystemObject(SystemObject newSystemObject)
  {
    SystemObject oldSystemObject = systemObject;
    systemObject = newSystemObject;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT, oldSystemObject, systemObject));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoModel getRelativZu()
  {
    if (relativZu != null && relativZu.eIsProxy())
    {
      InternalEObject oldRelativZu = (InternalEObject)relativZu;
      relativZu = (DoModel)eResolveProxy(oldRelativZu);
      if (relativZu != oldRelativZu)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU, oldRelativZu, relativZu));
      }
    }
    return relativZu;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoModel basicGetRelativZu()
  {
    return relativZu;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRelativZu(DoModel newRelativZu)
  {
    DoModel oldRelativZu = relativZu;
    relativZu = newRelativZu;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU, oldRelativZu, relativZu));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Point getAbsoluteLocation()
  {
    // TODO: implement this method to return the 'Absolute Location' attribute
    // Ensure that you remove @generated or mark it @generated NOT
    throw new UnsupportedOperationException();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getBezeichnung()
  {
    return bezeichnung;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBezeichnung(String newBezeichnung)
  {
    String oldBezeichnung = bezeichnung;
    bezeichnung = newBezeichnung;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__BEZEICHNUNG, oldBezeichnung, bezeichnung));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getKontext()
  {
    return kontext;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setKontext(int newKontext)
  {
    int oldKontext = kontext;
    kontext = newKontext;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KONTEXT, oldKontext, kontext));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getFahrtrichtung()
  {
    return fahrtrichtung;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFahrtrichtung(int newFahrtrichtung)
  {
    int oldFahrtrichtung = fahrtrichtung;
    fahrtrichtung = newFahrtrichtung;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__FAHRTRICHTUNG, oldFahrtrichtung, fahrtrichtung));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getDataUpdate()
  {
    return dataUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDataUpdate(Object newDataUpdate)
  {
    Object oldDataUpdate = dataUpdate;
    dataUpdate = newDataUpdate;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DATA_UPDATE, oldDataUpdate, dataUpdate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getDarstellungUpdate()
  {
    return darstellungUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDarstellungUpdate(Object newDarstellungUpdate)
  {
    Object oldDarstellungUpdate = darstellungUpdate;
    darstellungUpdate = newDarstellungUpdate;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DARSTELLUNG_UPDATE, oldDarstellungUpdate, darstellungUpdate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN:
        return ((InternalEList<?>)getKomponenten()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN:
        return getKomponenten();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME:
        return getName();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION:
        return getLocation();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP:
        if (resolve) return getDoTyp();
        return basicGetDoTyp();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT:
        return getSystemObject();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU:
        if (resolve) return getRelativZu();
        return basicGetRelativZu();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__ABSOLUTE_LOCATION:
        return getAbsoluteLocation();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__BEZEICHNUNG:
        return getBezeichnung();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KONTEXT:
        return getKontext();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__FAHRTRICHTUNG:
        return getFahrtrichtung();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DATA_UPDATE:
        return getDataUpdate();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        return getDarstellungUpdate();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN:
        getKomponenten().clear();
        getKomponenten().addAll((Collection<? extends AnzeigeModelTypAbstract>)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME:
        setName((String)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION:
        setLocation((Point)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP:
        setDoTyp((DoTyp)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT:
        setSystemObject((SystemObject)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU:
        setRelativZu((DoModel)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__BEZEICHNUNG:
        setBezeichnung((String)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KONTEXT:
        setKontext((Integer)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__FAHRTRICHTUNG:
        setFahrtrichtung((Integer)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DATA_UPDATE:
        setDataUpdate(newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        setDarstellungUpdate(newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN:
        getKomponenten().clear();
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME:
        setName(NAME_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION:
        setLocation(LOCATION_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP:
        setDoTyp((DoTyp)null);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT:
        setSystemObject(SYSTEM_OBJECT_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU:
        setRelativZu((DoModel)null);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__BEZEICHNUNG:
        setBezeichnung(BEZEICHNUNG_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KONTEXT:
        setKontext(KONTEXT_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__FAHRTRICHTUNG:
        setFahrtrichtung(FAHRTRICHTUNG_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DATA_UPDATE:
        setDataUpdate(DATA_UPDATE_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        setDarstellungUpdate(DARSTELLUNG_UPDATE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KOMPONENTEN:
        return komponenten != null && !komponenten.isEmpty();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION:
        return LOCATION_EDEFAULT == null ? location != null : !LOCATION_EDEFAULT.equals(location);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP:
        return doTyp != null;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT:
        return SYSTEM_OBJECT_EDEFAULT == null ? systemObject != null : !SYSTEM_OBJECT_EDEFAULT.equals(systemObject);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU:
        return relativZu != null;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__ABSOLUTE_LOCATION:
        return ABSOLUTE_LOCATION_EDEFAULT == null ? getAbsoluteLocation() != null : !ABSOLUTE_LOCATION_EDEFAULT.equals(getAbsoluteLocation());
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__BEZEICHNUNG:
        return BEZEICHNUNG_EDEFAULT == null ? bezeichnung != null : !BEZEICHNUNG_EDEFAULT.equals(bezeichnung);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__KONTEXT:
        return kontext != KONTEXT_EDEFAULT;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__FAHRTRICHTUNG:
        return fahrtrichtung != FAHRTRICHTUNG_EDEFAULT;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DATA_UPDATE:
        return DATA_UPDATE_EDEFAULT == null ? dataUpdate != null : !DATA_UPDATE_EDEFAULT.equals(dataUpdate);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        return DARSTELLUNG_UPDATE_EDEFAULT == null ? darstellungUpdate != null : !DARSTELLUNG_UPDATE_EDEFAULT.equals(darstellungUpdate);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == Named.class)
    {
      switch (derivedFeatureID)
      {
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME: return EclipsePackage.NAMED__NAME;
        default: return -1;
      }
    }
    if (baseClass == Located.class)
    {
      switch (derivedFeatureID)
      {
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION: return GefPackage.LOCATED__LOCATION;
        default: return -1;
      }
    }
    if (baseClass == DoModel.class)
    {
      switch (derivedFeatureID)
      {
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP: return DobjPackage.DO_MODEL__DO_TYP;
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT: return DobjPackage.DO_MODEL__SYSTEM_OBJECT;
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU: return DobjPackage.DO_MODEL__RELATIV_ZU;
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__ABSOLUTE_LOCATION: return DobjPackage.DO_MODEL__ABSOLUTE_LOCATION;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == Named.class)
    {
      switch (baseFeatureID)
      {
        case EclipsePackage.NAMED__NAME: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__NAME;
        default: return -1;
      }
    }
    if (baseClass == Located.class)
    {
      switch (baseFeatureID)
      {
        case GefPackage.LOCATED__LOCATION: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__LOCATION;
        default: return -1;
      }
    }
    if (baseClass == DoModel.class)
    {
      switch (baseFeatureID)
      {
        case DobjPackage.DO_MODEL__DO_TYP: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__DO_TYP;
        case DobjPackage.DO_MODEL__SYSTEM_OBJECT: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__SYSTEM_OBJECT;
        case DobjPackage.DO_MODEL__RELATIV_ZU: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__RELATIV_ZU;
        case DobjPackage.DO_MODEL__ABSOLUTE_LOCATION: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_NETZ_TYP_ABSTRACT__ABSOLUTE_LOCATION;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", location: ");
    result.append(location);
    result.append(", systemObject: ");
    result.append(systemObject);
    result.append(", Bezeichnung: ");
    result.append(bezeichnung);
    result.append(", Kontext: ");
    result.append(kontext);
    result.append(", Fahrtrichtung: ");
    result.append(fahrtrichtung);
    result.append(", DataUpdate: ");
    result.append(dataUpdate);
    result.append(", DarstellungUpdate: ");
    result.append(darstellungUpdate);
    result.append(')');
    return result.toString();
  }

} //AnzeigeQuerschnittModelNetzTypAbstractImpl
