/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.anlagendarstellung.semi;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

/**
 * Klasse realsiert eine {@link Shell} die sicherstellt, dass diese immer sichtbar ist
 * 
 * @author Pittner
 *
 */
public class ShellOnTop
{
	private static Shell _shell;

	public static Shell getShell(Shell parent, int style)
	{
		// int newStyle = style | SWT.APPLICATION_MODAL; // | SWT.ON_TOP;

		/*
		 * UrlasserDialog, Schalten-Dialog, Schalteempfehlungs-Dialog und
		 * Weiterschalten-Dialog sollen auf dieser Modalittsebene Arbeiten.
		 */
		int newStyle = style | SWT.APPLICATION_MODAL;
//		int newStyle = style | SWT.ON_TOP;

		_shell = new Shell(parent, newStyle);
		
		return _shell;
	}
}
