/**
 * <copyright>
 * </copyright>
 *
 * $Id: AlternativeStreckenAbschnitteImpl.java,v 1.2 2014/04/17 15:51:13 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Activateable;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivateableContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivationState;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AeussererStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AlternativeStreckenAbschnitte;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintraegeContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenTeilAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZugEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.ASACAktiverSAAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.ActivateableStateAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.AktiverStreckenAbschnittLaengeAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.AktiverStreckenAbschnittNameAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.WegeAdapter;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Alternative Strecken Abschnitte</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getState <em>State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getInternalState <em>Internal State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getActivateableContainer <em>Activateable Container</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getActivateables <em>Activateables</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getWegBisher <em>Weg Bisher</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getLaenge <em>Laenge</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getInternalAktiverStreckenAbschnitt <em>Internal Aktiver Strecken Abschnitt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getAktiverStreckenAbschnitt <em>Aktiver Strecken Abschnitt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getNachKnoten <em>Nach Knoten</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getVonKnoten <em>Von Knoten</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getStreckenTeilAbschnitt <em>Strecken Teil Abschnitt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.AlternativeStreckenAbschnitteImpl#getAnzeigeQuerschnitt <em>Anzeige Querschnitt</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AlternativeStreckenAbschnitteImpl extends EObjectImpl implements
		AlternativeStreckenAbschnitte {
	/**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
	protected static final String NAME_EDEFAULT = null;

	/**
   * The default value of the '{@link #getState() <em>State</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getState()
   * @generated
   * @ordered
   */
	protected static final ActivationState STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The default value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected static final ActivationState INTERNAL_STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The cached value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected ActivationState internalState = INTERNAL_STATE_EDEFAULT;

	/**
   * The cached value of the '{@link #getActivateables() <em>Activateables</em>}' containment reference list.
   * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
   * @see #getActivateables()
   * @generated
   * @ordered
   */
	protected EList<AeussererStreckenAbschnitt> activateables;

	/**
   * The default value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected static final double WEG_BISHER_EDEFAULT = 0.0;

	/**
   * The cached value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected double wegBisher = WEG_BISHER_EDEFAULT;

	/**
   * The default value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected static final Double LAENGE_EDEFAULT = null;

	/**
   * The cached value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected Double laenge = LAENGE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInternalAktiverStreckenAbschnitt()
	 * <em>Internal Aktiver Strecken Abschnitt</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInternalAktiverStreckenAbschnitt()
	 * @generated
	 * @ordered
	 */
	protected AeussererStreckenAbschnitt internalAktiverStreckenAbschnitt;

	/**
   * The cached value of the '{@link #getNachKnoten() <em>Nach Knoten</em>}' reference.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getNachKnoten()
   * @generated
   * @ordered
   */
	protected StreckenKnoten nachKnoten;

	/**
   * The cached value of the '{@link #getVonKnoten() <em>Von Knoten</em>}' reference.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getVonKnoten()
   * @generated
   * @ordered
   */
	protected StreckenKnoten vonKnoten;

	/**
	 * The cached value of the '{@link #getStreckenTeilAbschnitt()
	 * <em>Strecken Teil Abschnitt</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStreckenTeilAbschnitt()
	 * @generated
	 * @ordered
	 */
	protected EList<StreckenTeilAbschnitt> streckenTeilAbschnitt;

	/**
	 * The cached value of the '{@link #getAnzeigeQuerschnitt()
	 * <em>Anzeige Querschnitt</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAnzeigeQuerschnitt()
	 * @generated
	 * @ordered
	 */
	protected EList<AnzeigeQuerschnitt> anzeigeQuerschnitt;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected AlternativeStreckenAbschnitteImpl() {
		super();
		new ActivateableStateAdapter(this);
		new AktiverStreckenAbschnittNameAdapter(this);
		new AktiverStreckenAbschnittLaengeAdapter(this);
		new WegeAdapter(this);
		new ASACAktiverSAAdapter(this);
	}

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	protected EClass eStaticClass() {
    return StreckenprofilPackage.Literals.ALTERNATIVE_STRECKEN_ABSCHNITTE;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getName() {
    final de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Named named = getAktiverStreckenAbschnitt();
    return "=> " + (null == named ? "Bitte auswhlen..." : named.getName());
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setName(String newName) {
    // TODO: implement this method to set the 'Name' attribute
    // Ensure that you remove @generated or mark it @generated NOT
    throw new UnsupportedOperationException();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getState() {
    return getInternalState();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setState(ActivationState newValue) {
    de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.Activateables.dispatchSetActive(this, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getInternalState() {
    return internalState;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setInternalState(ActivationState newInternalState) {
    ActivationState oldInternalState = internalState;
    internalState = newInternalState == null ? INTERNAL_STATE_EDEFAULT : newInternalState;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_STATE, oldInternalState, internalState));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivateableContainer<?> getActivateableContainer() {
    if (eContainerFeatureID() != StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER) return null;
    return (ActivateableContainer<?>)eContainer();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public NotificationChain basicSetActivateableContainer(
			ActivateableContainer<?> newActivateableContainer,
			NotificationChain msgs) {
    msgs = eBasicSetContainer((InternalEObject)newActivateableContainer, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER, msgs);
    return msgs;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setActivateableContainer(
			ActivateableContainer<?> newActivateableContainer) {
    if (newActivateableContainer != eInternalContainer() || (eContainerFeatureID() != StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER && newActivateableContainer != null))
    {
      if (EcoreUtil.isAncestor(this, newActivateableContainer))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newActivateableContainer != null)
        msgs = ((InternalEObject)newActivateableContainer).eInverseAdd(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
      msgs = basicSetActivateableContainer(newActivateableContainer, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER, newActivateableContainer, newActivateableContainer));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<AeussererStreckenAbschnitt> getActivateables() {
    if (activateables == null)
    {
      activateables = new EObjectContainmentWithInverseEList<AeussererStreckenAbschnitt>(Activateable.class, this, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES, StreckenprofilPackage.ACTIVATEABLE__ACTIVATEABLE_CONTAINER);
    }
    return activateables;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public double getWegBisher() {
    return wegBisher;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setWegBisher(double newWegBisher) {
    double oldWegBisher = wegBisher;
    wegBisher = newWegBisher;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER, oldWegBisher, wegBisher));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double getLaenge() {
    return laenge;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setLaenge(Double newLaenge) {
    Double oldLaenge = laenge;
    laenge = newLaenge;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE, oldLaenge, laenge));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public AeussererStreckenAbschnitt getInternalAktiverStreckenAbschnitt() {
    if (internalAktiverStreckenAbschnitt != null && internalAktiverStreckenAbschnitt.eIsProxy())
    {
      InternalEObject oldInternalAktiverStreckenAbschnitt = (InternalEObject)internalAktiverStreckenAbschnitt;
      internalAktiverStreckenAbschnitt = (AeussererStreckenAbschnitt)eResolveProxy(oldInternalAktiverStreckenAbschnitt);
      if (internalAktiverStreckenAbschnitt != oldInternalAktiverStreckenAbschnitt)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT, oldInternalAktiverStreckenAbschnitt, internalAktiverStreckenAbschnitt));
      }
    }
    return internalAktiverStreckenAbschnitt;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public AeussererStreckenAbschnitt basicGetInternalAktiverStreckenAbschnitt() {
    return internalAktiverStreckenAbschnitt;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setInternalAktiverStreckenAbschnitt(
			AeussererStreckenAbschnitt newInternalAktiverStreckenAbschnitt) {
    AeussererStreckenAbschnitt oldInternalAktiverStreckenAbschnitt = internalAktiverStreckenAbschnitt;
    internalAktiverStreckenAbschnitt = newInternalAktiverStreckenAbschnitt;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT, oldInternalAktiverStreckenAbschnitt, internalAktiverStreckenAbschnitt));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public AeussererStreckenAbschnitt getAktiverStreckenAbschnitt() {
    return getInternalAktiverStreckenAbschnitt();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setAktiverStreckenAbschnitt(AeussererStreckenAbschnitt newValue) {
    newValue.setState(ActivationState.ACTIVE);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenKnoten getNachKnoten() {
    if (nachKnoten != null && nachKnoten.eIsProxy())
    {
      InternalEObject oldNachKnoten = (InternalEObject)nachKnoten;
      nachKnoten = (StreckenKnoten)eResolveProxy(oldNachKnoten);
      if (nachKnoten != oldNachKnoten)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN, oldNachKnoten, nachKnoten));
      }
    }
    return nachKnoten;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenKnoten basicGetNachKnoten() {
    return nachKnoten;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public NotificationChain basicSetNachKnoten(StreckenKnoten newNachKnoten,
			NotificationChain msgs) {
    StreckenKnoten oldNachKnoten = nachKnoten;
    nachKnoten = newNachKnoten;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN, oldNachKnoten, newNachKnoten);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setNachKnoten(StreckenKnoten newNachKnoten) {
    if (newNachKnoten != nachKnoten)
    {
      NotificationChain msgs = null;
      if (nachKnoten != null)
        msgs = ((InternalEObject)nachKnoten).eInverseRemove(this, StreckenprofilPackage.STRECKEN_KNOTEN__VON_STRECKE, StreckenKnoten.class, msgs);
      if (newNachKnoten != null)
        msgs = ((InternalEObject)newNachKnoten).eInverseAdd(this, StreckenprofilPackage.STRECKEN_KNOTEN__VON_STRECKE, StreckenKnoten.class, msgs);
      msgs = basicSetNachKnoten(newNachKnoten, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN, newNachKnoten, newNachKnoten));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenKnoten getVonKnoten() {
    if (vonKnoten != null && vonKnoten.eIsProxy())
    {
      InternalEObject oldVonKnoten = (InternalEObject)vonKnoten;
      vonKnoten = (StreckenKnoten)eResolveProxy(oldVonKnoten);
      if (vonKnoten != oldVonKnoten)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN, oldVonKnoten, vonKnoten));
      }
    }
    return vonKnoten;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenKnoten basicGetVonKnoten() {
    return vonKnoten;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public NotificationChain basicSetVonKnoten(StreckenKnoten newVonKnoten,
			NotificationChain msgs) {
    StreckenKnoten oldVonKnoten = vonKnoten;
    vonKnoten = newVonKnoten;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN, oldVonKnoten, newVonKnoten);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setVonKnoten(StreckenKnoten newVonKnoten) {
    if (newVonKnoten != vonKnoten)
    {
      NotificationChain msgs = null;
      if (vonKnoten != null)
        msgs = ((InternalEObject)vonKnoten).eInverseRemove(this, StreckenprofilPackage.STRECKEN_KNOTEN__NACH_STRECKE, StreckenKnoten.class, msgs);
      if (newVonKnoten != null)
        msgs = ((InternalEObject)newVonKnoten).eInverseAdd(this, StreckenprofilPackage.STRECKEN_KNOTEN__NACH_STRECKE, StreckenKnoten.class, msgs);
      msgs = basicSetVonKnoten(newVonKnoten, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN, newVonKnoten, newVonKnoten));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<StreckenTeilAbschnitt> getStreckenTeilAbschnitt() {
    if (streckenTeilAbschnitt == null)
    {
      streckenTeilAbschnitt = new EObjectContainmentEList<StreckenTeilAbschnitt>(StreckenTeilAbschnitt.class, this, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT);
    }
    return streckenTeilAbschnitt;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<AnzeigeQuerschnitt> getAnzeigeQuerschnitt() {
    if (anzeigeQuerschnitt == null)
    {
      anzeigeQuerschnitt = new EObjectContainmentEList<AnzeigeQuerschnitt>(AnzeigeQuerschnitt.class, this, StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT);
    }
    return anzeigeQuerschnitt;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double computeLaenge() {
    StreckenAbschnitt abschnitt=getAktiverStreckenAbschnitt();
    return null != abschnitt ? abschnitt.getLaenge() : null;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenEintraegeContainer<?> getStreckenEintraegeContainer() {
    return (StreckenEintraegeContainer<?>) getActivateableContainer();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setStreckenEintraegeContainer(
			StreckenEintraegeContainer<?> container) {
    setActivateableContainer(container);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<AeussererStreckenAbschnitt> getStreckenEintraege() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<AeussererStreckenAbschnitt> getStreckenZugEintraege() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetActivateableContainer((ActivateableContainer<?>)otherEnd, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getActivateables()).basicAdd(otherEnd, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        if (nachKnoten != null)
          msgs = ((InternalEObject)nachKnoten).eInverseRemove(this, StreckenprofilPackage.STRECKEN_KNOTEN__VON_STRECKE, StreckenKnoten.class, msgs);
        return basicSetNachKnoten((StreckenKnoten)otherEnd, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        if (vonKnoten != null)
          msgs = ((InternalEObject)vonKnoten).eInverseRemove(this, StreckenprofilPackage.STRECKEN_KNOTEN__NACH_STRECKE, StreckenKnoten.class, msgs);
        return basicSetVonKnoten((StreckenKnoten)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        return basicSetActivateableContainer(null, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        return ((InternalEList<?>)getActivateables()).basicRemove(otherEnd, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        return basicSetNachKnoten(null, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        return basicSetVonKnoten(null, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT:
        return ((InternalEList<?>)getStreckenTeilAbschnitt()).basicRemove(otherEnd, msgs);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT:
        return ((InternalEList<?>)getAnzeigeQuerschnitt()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
    switch (eContainerFeatureID())
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        return eInternalContainer().eInverseRemove(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NAME:
        return getName();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STATE:
        return getState();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_STATE:
        return getInternalState();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        return getActivateables();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER:
        return getWegBisher();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE:
        return getLaenge();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT:
        if (resolve) return getInternalAktiverStreckenAbschnitt();
        return basicGetInternalAktiverStreckenAbschnitt();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__AKTIVER_STRECKEN_ABSCHNITT:
        return getAktiverStreckenAbschnitt();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        if (resolve) return getNachKnoten();
        return basicGetNachKnoten();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        if (resolve) return getVonKnoten();
        return basicGetVonKnoten();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT:
        return getStreckenTeilAbschnitt();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT:
        return getAnzeigeQuerschnitt();
    }
    return super.eGet(featureID, resolve, coreType);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NAME:
        setName((String)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STATE:
        setState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_STATE:
        setInternalState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        getActivateables().clear();
        getActivateables().addAll((Collection<? extends AeussererStreckenAbschnitt>)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER:
        setWegBisher((Double)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE:
        setLaenge((Double)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT:
        setInternalAktiverStreckenAbschnitt((AeussererStreckenAbschnitt)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__AKTIVER_STRECKEN_ABSCHNITT:
        setAktiverStreckenAbschnitt((AeussererStreckenAbschnitt)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        setNachKnoten((StreckenKnoten)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        setVonKnoten((StreckenKnoten)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT:
        getStreckenTeilAbschnitt().clear();
        getStreckenTeilAbschnitt().addAll((Collection<? extends StreckenTeilAbschnitt>)newValue);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT:
        getAnzeigeQuerschnitt().clear();
        getAnzeigeQuerschnitt().addAll((Collection<? extends AnzeigeQuerschnitt>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public void eUnset(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NAME:
        setName(NAME_EDEFAULT);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STATE:
        setState(STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_STATE:
        setInternalState(INTERNAL_STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)null);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        getActivateables().clear();
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER:
        setWegBisher(WEG_BISHER_EDEFAULT);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE:
        setLaenge(LAENGE_EDEFAULT);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT:
        setInternalAktiverStreckenAbschnitt((AeussererStreckenAbschnitt)null);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__AKTIVER_STRECKEN_ABSCHNITT:
        setAktiverStreckenAbschnitt((AeussererStreckenAbschnitt)null);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        setNachKnoten((StreckenKnoten)null);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        setVonKnoten((StreckenKnoten)null);
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT:
        getStreckenTeilAbschnitt().clear();
        return;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT:
        getAnzeigeQuerschnitt().clear();
        return;
    }
    super.eUnset(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public boolean eIsSet(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NAME:
        return NAME_EDEFAULT == null ? getName() != null : !NAME_EDEFAULT.equals(getName());
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STATE:
        return getState() != STATE_EDEFAULT;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_STATE:
        return internalState != INTERNAL_STATE_EDEFAULT;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer() != null;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ACTIVATEABLES:
        return activateables != null && !activateables.isEmpty();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER:
        return wegBisher != WEG_BISHER_EDEFAULT;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE:
        return LAENGE_EDEFAULT == null ? laenge != null : !LAENGE_EDEFAULT.equals(laenge);
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__INTERNAL_AKTIVER_STRECKEN_ABSCHNITT:
        return internalAktiverStreckenAbschnitt != null;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__AKTIVER_STRECKEN_ABSCHNITT:
        return getAktiverStreckenAbschnitt() != null;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN:
        return nachKnoten != null;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN:
        return vonKnoten != null;
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT:
        return streckenTeilAbschnitt != null && !streckenTeilAbschnitt.isEmpty();
      case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT:
        return anzeigeQuerschnitt != null && !anzeigeQuerschnitt.isEmpty();
    }
    return super.eIsSet(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER;
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE;
        default: return -1;
      }
    }
    if (baseClass == StreckenEintrag.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == StreckenAbschnitt.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN: return StreckenprofilPackage.STRECKEN_ABSCHNITT__NACH_KNOTEN;
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN: return StreckenprofilPackage.STRECKEN_ABSCHNITT__VON_KNOTEN;
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT: return StreckenprofilPackage.STRECKEN_ABSCHNITT__STRECKEN_TEIL_ABSCHNITT;
        case StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT: return StreckenprofilPackage.STRECKEN_ABSCHNITT__ANZEIGE_QUERSCHNITT;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__WEG_BISHER;
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__LAENGE;
        default: return -1;
      }
    }
    if (baseClass == StreckenEintrag.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == StreckenAbschnitt.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.STRECKEN_ABSCHNITT__NACH_KNOTEN: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__NACH_KNOTEN;
        case StreckenprofilPackage.STRECKEN_ABSCHNITT__VON_KNOTEN: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__VON_KNOTEN;
        case StreckenprofilPackage.STRECKEN_ABSCHNITT__STRECKEN_TEIL_ABSCHNITT: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__STRECKEN_TEIL_ABSCHNITT;
        case StreckenprofilPackage.STRECKEN_ABSCHNITT__ANZEIGE_QUERSCHNITT: return StreckenprofilPackage.ALTERNATIVE_STRECKEN_ABSCHNITTE__ANZEIGE_QUERSCHNITT;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String toString() {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (internalState: ");
    result.append(internalState);
    result.append(", wegBisher: ");
    result.append(wegBisher);
    result.append(", laenge: ");
    result.append(laenge);
    result.append(')');
    return result.toString();
  }

} // AlternativeStreckenAbschnitteImpl
