/**
 * <copyright>
 * </copyright>
 *
 * $Id: StreckeImpl.java,v 1.2 2014/04/17 15:51:14 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Activateable;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivateableContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivationState;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintraegeContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZug;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZugEintraegeContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZugEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.ActivateableStateAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.StreckenZugEintragContainerLaengeAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.WegeAdapter;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Strasse;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Strecke</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getState <em>State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getInternalState <em>Internal State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getActivateableContainer <em>Activateable Container</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getActivateables <em>Activateables</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getWegBisher <em>Weg Bisher</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getLaenge <em>Laenge</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckeImpl#getRichtung <em>Richtung</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StreckeImpl extends SystemObjektContainerImpl<Strasse> implements
		Strecke {
	/**
   * The default value of the '{@link #getState() <em>State</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getState()
   * @generated
   * @ordered
   */
	protected static final ActivationState STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The default value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected static final ActivationState INTERNAL_STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The cached value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected ActivationState internalState = INTERNAL_STATE_EDEFAULT;

	/**
   * The cached value of the '{@link #getActivateables() <em>Activateables</em>}' containment reference list.
   * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
   * @see #getActivateables()
   * @generated
   * @ordered
   */
	protected EList<StreckenEintrag> activateables;

	/**
   * The default value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected static final double WEG_BISHER_EDEFAULT = 0.0;

	/**
   * The cached value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected double wegBisher = WEG_BISHER_EDEFAULT;

	/**
   * The default value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected static final Double LAENGE_EDEFAULT = null;

	/**
   * The cached value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected Double laenge = LAENGE_EDEFAULT;

	/**
   * The default value of the '{@link #getRichtung() <em>Richtung</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getRichtung()
   * @generated
   * @ordered
   */
	protected static final AttTmcRichtung RICHTUNG_EDEFAULT = null;

	/**
   * The cached value of the '{@link #getRichtung() <em>Richtung</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getRichtung()
   * @generated
   * @ordered
   */
	protected AttTmcRichtung richtung = RICHTUNG_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected StreckeImpl() {
		super();
		new ActivateableStateAdapter(this);
		new StreckenZugEintragContainerLaengeAdapter(this);
		new WegeAdapter(this);

	}

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	protected EClass eStaticClass() {
    return StreckenprofilPackage.Literals.STRECKE;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getState() {
    return getInternalState();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setState(ActivationState newValue) {
    de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.Activateables.dispatchSetActive(this, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getInternalState() {
    return internalState;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setInternalState(ActivationState newInternalState) {
    ActivationState oldInternalState = internalState;
    internalState = newInternalState == null ? INTERNAL_STATE_EDEFAULT : newInternalState;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKE__INTERNAL_STATE, oldInternalState, internalState));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivateableContainer<?> getActivateableContainer() {
    if (eContainerFeatureID() != StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER) return null;
    return (ActivateableContainer<?>)eContainer();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public NotificationChain basicSetActivateableContainer(
			ActivateableContainer<?> newActivateableContainer,
			NotificationChain msgs) {
    msgs = eBasicSetContainer((InternalEObject)newActivateableContainer, StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER, msgs);
    return msgs;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setActivateableContainer(
			ActivateableContainer<?> newActivateableContainer) {
    if (newActivateableContainer != eInternalContainer() || (eContainerFeatureID() != StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER && newActivateableContainer != null))
    {
      if (EcoreUtil.isAncestor(this, newActivateableContainer))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newActivateableContainer != null)
        msgs = ((InternalEObject)newActivateableContainer).eInverseAdd(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
      msgs = basicSetActivateableContainer(newActivateableContainer, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER, newActivateableContainer, newActivateableContainer));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<StreckenEintrag> getActivateables() {
    if (activateables == null)
    {
      activateables = new EObjectContainmentWithInverseEList<StreckenEintrag>(Activateable.class, this, StreckenprofilPackage.STRECKE__ACTIVATEABLES, StreckenprofilPackage.ACTIVATEABLE__ACTIVATEABLE_CONTAINER);
    }
    return activateables;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public double getWegBisher() {
    return wegBisher;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setWegBisher(double newWegBisher) {
    double oldWegBisher = wegBisher;
    wegBisher = newWegBisher;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKE__WEG_BISHER, oldWegBisher, wegBisher));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double getLaenge() {
    return laenge;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setLaenge(Double newLaenge) {
    Double oldLaenge = laenge;
    laenge = newLaenge;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKE__LAENGE, oldLaenge, laenge));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public AttTmcRichtung getRichtung() {
    return richtung;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setRichtung(AttTmcRichtung newRichtung) {
    AttTmcRichtung oldRichtung = richtung;
    richtung = newRichtung;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKE__RICHTUNG, oldRichtung, richtung));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Strasse getStrasse() {
    return getModellObjekt();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setStrasse(Strasse strasse) {
    setModellObjekt(strasse);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double computeLaenge() {
    double laenge = 0;
    for (StreckenEintrag streckenEintrag : getStreckenEintraege()) {
      Double l = streckenEintrag.getLaenge();
      if (null != l) {
        laenge += l;
      }
    }
    return laenge;
    
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public StreckenZug getStreckenZug() {
    return (StreckenZug) getActivateableContainer();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String getName() {
    return getStrasse() != null ? de.bsvrz.buv.rw.bitctrl.startup.StartupPlugin
            .getDefault().getDefaultNetzCache().getStrassenName(
                getStrasse(), getRichtung())
            : "[Undefiniert]";
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public int compareTo(Strecke o) {
    final boolean top1 = null != getActivateableContainer();
    final boolean top2 = null != o.getActivateableContainer();
    if (top1 ^ !top2) { // XAND
      return getName().compareTo(o.getName());
    } else if (top1) {
      return -1;
    } else {
      return 1;
    }
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (obj == null) {
      return false;
    }
    if (getClass() != obj.getClass()) {
      return false;
    }
    final StreckeImpl other = (StreckeImpl) obj;
    if (modellObjekt == null) {
      if (other.modellObjekt != null) {
        return false;
      }
    } else if (!modellObjekt.equals(other.modellObjekt)) {
      return false;
    }
    if (richtung == null) {
      if (other.richtung != null) {
        return false;
      }
    } else if (!richtung.equals(other.richtung)) {
      return false;
    }
    if (internalState == null) {
      if (other.internalState != null) {
        return false;
      }
    } else if (!internalState.equals(other.internalState)) {
      return false;
    }
    return true;
    
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result
        + ((modellObjekt == null) ? 0 : modellObjekt.hashCode());
    result = prime * result
        + ((richtung == null) ? 0 : richtung.hashCode());
    result = prime * result + ((internalState == null) ? 0 : internalState.hashCode());
    return result;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<StreckenEintrag> getStreckenEintraege() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<StreckenEintrag> getStreckenZugEintraege() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetActivateableContainer((ActivateableContainer<?>)otherEnd, msgs);
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getActivateables()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        return basicSetActivateableContainer(null, msgs);
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        return ((InternalEList<?>)getActivateables()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
    switch (eContainerFeatureID())
    {
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        return eInternalContainer().eInverseRemove(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__STATE:
        return getState();
      case StreckenprofilPackage.STRECKE__INTERNAL_STATE:
        return getInternalState();
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer();
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        return getActivateables();
      case StreckenprofilPackage.STRECKE__WEG_BISHER:
        return getWegBisher();
      case StreckenprofilPackage.STRECKE__LAENGE:
        return getLaenge();
      case StreckenprofilPackage.STRECKE__RICHTUNG:
        return getRichtung();
    }
    return super.eGet(featureID, resolve, coreType);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__STATE:
        setState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.STRECKE__INTERNAL_STATE:
        setInternalState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)newValue);
        return;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        getActivateables().clear();
        getActivateables().addAll((Collection<? extends StreckenEintrag>)newValue);
        return;
      case StreckenprofilPackage.STRECKE__WEG_BISHER:
        setWegBisher((Double)newValue);
        return;
      case StreckenprofilPackage.STRECKE__LAENGE:
        setLaenge((Double)newValue);
        return;
      case StreckenprofilPackage.STRECKE__RICHTUNG:
        setRichtung((AttTmcRichtung)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public void eUnset(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__STATE:
        setState(STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKE__INTERNAL_STATE:
        setInternalState(INTERNAL_STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)null);
        return;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        getActivateables().clear();
        return;
      case StreckenprofilPackage.STRECKE__WEG_BISHER:
        setWegBisher(WEG_BISHER_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKE__LAENGE:
        setLaenge(LAENGE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKE__RICHTUNG:
        setRichtung(RICHTUNG_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public boolean eIsSet(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKE__STATE:
        return getState() != STATE_EDEFAULT;
      case StreckenprofilPackage.STRECKE__INTERNAL_STATE:
        return internalState != INTERNAL_STATE_EDEFAULT;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer() != null;
      case StreckenprofilPackage.STRECKE__ACTIVATEABLES:
        return activateables != null && !activateables.isEmpty();
      case StreckenprofilPackage.STRECKE__WEG_BISHER:
        return wegBisher != WEG_BISHER_EDEFAULT;
      case StreckenprofilPackage.STRECKE__LAENGE:
        return LAENGE_EDEFAULT == null ? laenge != null : !LAENGE_EDEFAULT.equals(laenge);
      case StreckenprofilPackage.STRECKE__RICHTUNG:
        return RICHTUNG_EDEFAULT == null ? richtung != null : !RICHTUNG_EDEFAULT.equals(richtung);
    }
    return super.eIsSet(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
    if (baseClass == Activateable.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.STRECKE__STATE: return StreckenprofilPackage.ACTIVATEABLE__STATE;
        case StreckenprofilPackage.STRECKE__INTERNAL_STATE: return StreckenprofilPackage.ACTIVATEABLE__INTERNAL_STATE;
        case StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER: return StreckenprofilPackage.ACTIVATEABLE__ACTIVATEABLE_CONTAINER;
        default: return -1;
      }
    }
    if (baseClass == ActivateableContainer.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.STRECKE__ACTIVATEABLES: return StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES;
        default: return -1;
      }
    }
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.STRECKE__WEG_BISHER: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER;
        case StreckenprofilPackage.STRECKE__LAENGE: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE;
        default: return -1;
      }
    }
    if (baseClass == StreckenZugEintraegeContainer.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == StreckenEintraegeContainer.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == Comparable.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
    if (baseClass == Activateable.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.ACTIVATEABLE__STATE: return StreckenprofilPackage.STRECKE__STATE;
        case StreckenprofilPackage.ACTIVATEABLE__INTERNAL_STATE: return StreckenprofilPackage.STRECKE__INTERNAL_STATE;
        case StreckenprofilPackage.ACTIVATEABLE__ACTIVATEABLE_CONTAINER: return StreckenprofilPackage.STRECKE__ACTIVATEABLE_CONTAINER;
        default: return -1;
      }
    }
    if (baseClass == ActivateableContainer.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES: return StreckenprofilPackage.STRECKE__ACTIVATEABLES;
        default: return -1;
      }
    }
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER: return StreckenprofilPackage.STRECKE__WEG_BISHER;
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE: return StreckenprofilPackage.STRECKE__LAENGE;
        default: return -1;
      }
    }
    if (baseClass == StreckenZugEintraegeContainer.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == StreckenEintraegeContainer.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == Comparable.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String toString() {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (internalState: ");
    result.append(internalState);
    result.append(", wegBisher: ");
    result.append(wegBisher);
    result.append(", laenge: ");
    result.append(laenge);
    result.append(", richtung: ");
    result.append(richtung);
    result.append(')');
    return result.toString();
  }

} // StreckeImpl
