package de.bsvrz.buv.plugin.pua.a8.projektInfo;

import java.util.HashMap;
import java.util.Map;

public class ProjektInfoNsSsw extends ProjektInfoUfdAbstrakt
{
  
  public ProjektInfoNsSsw() {
    super();
    
    _ausgabeTabelleSpalten.add("Stufe");
    
  }

  protected Map<String, String> specialValuesMap = new HashMap<String, String>() {
    {
      put("unplausibel", "-1");
      put("nicht ermittelbar", "-1");
      put("darf nicht ermittelt werden", "-1");
    }
  };
  
  protected Map<String, String> _nsValuesMap = new HashMap<String, String>() {
    {
      put("trocken", "0");
      put("feucht", "0,5");
      put("nass1", "1");
      put("nass2", "2");
      put("nass3", "3");
      put("Platzregen", "4");
    }
  };
  
  @Override
  public String getWertKonvertiert(String attribut, String wert, String objekt)
  {
    String result = null;
    if (wert != null && _ausgabeTabelleSpalten.get(0).equals(attribut)) {
      result = _nsValuesMap.get(wert);
      if (result == null) {
        result = specialValuesMap.get(wert);
      }
    }
    return result;
  }
  
  

}
