/**
 * <copyright>
 * </copyright>
 *
 * $Id: StreckenZugImpl.java,v 1.2 2014/04/17 15:51:14 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Activateable;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivateableContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivationState;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZug;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZugEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.ActivateableStateAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.StreckenzugNameAdapter;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter.WegeAdapter;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Strecken Zug</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getState <em>State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getInternalState <em>Internal State</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getActivateableContainer <em>Activateable Container</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getActivateables <em>Activateables</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getWegBisher <em>Weg Bisher</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getLaenge <em>Laenge</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.impl.StreckenZugImpl#getStreckenzugName <em>Streckenzug Name</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StreckenZugImpl extends EObjectImpl implements StreckenZug {
	/**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
	protected static final String NAME_EDEFAULT = null;

	/**
   * The default value of the '{@link #getState() <em>State</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getState()
   * @generated
   * @ordered
   */
	protected static final ActivationState STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The default value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected static final ActivationState INTERNAL_STATE_EDEFAULT = ActivationState.INACTIVE;

	/**
   * The cached value of the '{@link #getInternalState() <em>Internal State</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getInternalState()
   * @generated
   * @ordered
   */
	protected ActivationState internalState = INTERNAL_STATE_EDEFAULT;

	/**
   * The cached value of the '{@link #getActivateables() <em>Activateables</em>}' containment reference list.
   * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
   * @see #getActivateables()
   * @generated
   * @ordered
   */
	protected EList<Strecke> activateables;

	/**
   * The default value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected static final double WEG_BISHER_EDEFAULT = 0.0;

	/**
   * The cached value of the '{@link #getWegBisher() <em>Weg Bisher</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getWegBisher()
   * @generated
   * @ordered
   */
	protected double wegBisher = WEG_BISHER_EDEFAULT;

	/**
   * The default value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected static final Double LAENGE_EDEFAULT = null;

	/**
   * The cached value of the '{@link #getLaenge() <em>Laenge</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #getLaenge()
   * @generated
   * @ordered
   */
	protected Double laenge = LAENGE_EDEFAULT;

	/**
   * The default value of the '{@link #getStreckenzugName() <em>Streckenzug Name</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getStreckenzugName()
   * @generated
   * @ordered
   */
	protected static final String STRECKENZUG_NAME_EDEFAULT = null;

	/**
   * The cached value of the '{@link #getStreckenzugName() <em>Streckenzug Name</em>}' attribute.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #getStreckenzugName()
   * @generated
   * @ordered
   */
	protected String streckenzugName = STRECKENZUG_NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected StreckenZugImpl() {
		super();
		new ActivateableStateAdapter(this);
		new WegeAdapter(this);
		new StreckenzugNameAdapter(this);
	}

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	protected EClass eStaticClass() {
    return StreckenprofilPackage.Literals.STRECKEN_ZUG;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getName() {
    return getStreckenzugName();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setName(String neuerName) {
    setStreckenzugName(neuerName);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getState() {
    return getInternalState();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setState(ActivationState newValue) {
    de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.Activateables.dispatchSetActive(this, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivationState getInternalState() {
    return internalState;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setInternalState(ActivationState newInternalState) {
    ActivationState oldInternalState = internalState;
    internalState = newInternalState == null ? INTERNAL_STATE_EDEFAULT : newInternalState;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKEN_ZUG__INTERNAL_STATE, oldInternalState, internalState));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public ActivateableContainer<?> getActivateableContainer() {
    if (eContainerFeatureID() != StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER) return null;
    return (ActivateableContainer<?>)eContainer();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public NotificationChain basicSetActivateableContainer(
			ActivateableContainer<?> newActivateableContainer,
			NotificationChain msgs) {
    msgs = eBasicSetContainer((InternalEObject)newActivateableContainer, StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER, msgs);
    return msgs;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setActivateableContainer(
			ActivateableContainer<?> newActivateableContainer) {
    if (newActivateableContainer != eInternalContainer() || (eContainerFeatureID() != StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER && newActivateableContainer != null))
    {
      if (EcoreUtil.isAncestor(this, newActivateableContainer))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newActivateableContainer != null)
        msgs = ((InternalEObject)newActivateableContainer).eInverseAdd(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
      msgs = basicSetActivateableContainer(newActivateableContainer, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER, newActivateableContainer, newActivateableContainer));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<Strecke> getActivateables() {
    if (activateables == null)
    {
      activateables = new EObjectContainmentWithInverseEList<Strecke>(Activateable.class, this, StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES, StreckenprofilPackage.ACTIVATEABLE__ACTIVATEABLE_CONTAINER);
    }
    return activateables;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public double getWegBisher() {
    return wegBisher;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setWegBisher(double newWegBisher) {
    double oldWegBisher = wegBisher;
    wegBisher = newWegBisher;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER, oldWegBisher, wegBisher));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double getLaenge() {
    return laenge;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setLaenge(Double newLaenge) {
    Double oldLaenge = laenge;
    laenge = newLaenge;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKEN_ZUG__LAENGE, oldLaenge, laenge));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getStreckenzugName() {
    return streckenzugName;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public void setStreckenzugName(String newStreckenzugName) {
    String oldStreckenzugName = streckenzugName;
    streckenzugName = newStreckenzugName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StreckenprofilPackage.STRECKEN_ZUG__STRECKENZUG_NAME, oldStreckenzugName, streckenzugName));
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<Strecke> getStrecken() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public EList<Strecke> getStreckenZugEintraege() {
    return getActivateables();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public Double computeLaenge() {
    // TODO: implement this method
    // Ensure that you remove @generated or mark it @generated NOT
    throw new UnsupportedOperationException();
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetActivateableContainer((ActivateableContainer<?>)otherEnd, msgs);
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getActivateables()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        return basicSetActivateableContainer(null, msgs);
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        return ((InternalEList<?>)getActivateables()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
    switch (eContainerFeatureID())
    {
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        return eInternalContainer().eInverseRemove(this, StreckenprofilPackage.ACTIVATEABLE_CONTAINER__ACTIVATEABLES, ActivateableContainer.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__NAME:
        return getName();
      case StreckenprofilPackage.STRECKEN_ZUG__STATE:
        return getState();
      case StreckenprofilPackage.STRECKEN_ZUG__INTERNAL_STATE:
        return getInternalState();
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer();
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        return getActivateables();
      case StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER:
        return getWegBisher();
      case StreckenprofilPackage.STRECKEN_ZUG__LAENGE:
        return getLaenge();
      case StreckenprofilPackage.STRECKEN_ZUG__STRECKENZUG_NAME:
        return getStreckenzugName();
    }
    return super.eGet(featureID, resolve, coreType);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__NAME:
        setName((String)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__STATE:
        setState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__INTERNAL_STATE:
        setInternalState((ActivationState)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        getActivateables().clear();
        getActivateables().addAll((Collection<? extends Strecke>)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER:
        setWegBisher((Double)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__LAENGE:
        setLaenge((Double)newValue);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__STRECKENZUG_NAME:
        setStreckenzugName((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public void eUnset(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__NAME:
        setName(NAME_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__STATE:
        setState(STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__INTERNAL_STATE:
        setInternalState(INTERNAL_STATE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        setActivateableContainer((ActivateableContainer<?>)null);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        getActivateables().clear();
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER:
        setWegBisher(WEG_BISHER_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__LAENGE:
        setLaenge(LAENGE_EDEFAULT);
        return;
      case StreckenprofilPackage.STRECKEN_ZUG__STRECKENZUG_NAME:
        setStreckenzugName(STRECKENZUG_NAME_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public boolean eIsSet(int featureID) {
    switch (featureID)
    {
      case StreckenprofilPackage.STRECKEN_ZUG__NAME:
        return NAME_EDEFAULT == null ? getName() != null : !NAME_EDEFAULT.equals(getName());
      case StreckenprofilPackage.STRECKEN_ZUG__STATE:
        return getState() != STATE_EDEFAULT;
      case StreckenprofilPackage.STRECKEN_ZUG__INTERNAL_STATE:
        return internalState != INTERNAL_STATE_EDEFAULT;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLE_CONTAINER:
        return getActivateableContainer() != null;
      case StreckenprofilPackage.STRECKEN_ZUG__ACTIVATEABLES:
        return activateables != null && !activateables.isEmpty();
      case StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER:
        return wegBisher != WEG_BISHER_EDEFAULT;
      case StreckenprofilPackage.STRECKEN_ZUG__LAENGE:
        return LAENGE_EDEFAULT == null ? laenge != null : !LAENGE_EDEFAULT.equals(laenge);
      case StreckenprofilPackage.STRECKEN_ZUG__STRECKENZUG_NAME:
        return STRECKENZUG_NAME_EDEFAULT == null ? streckenzugName != null : !STRECKENZUG_NAME_EDEFAULT.equals(streckenzugName);
    }
    return super.eIsSet(featureID);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (derivedFeatureID)
      {
        case StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER;
        case StreckenprofilPackage.STRECKEN_ZUG__LAENGE: return StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
    if (baseClass == StreckenZugEintrag.class)
    {
      switch (baseFeatureID)
      {
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__WEG_BISHER: return StreckenprofilPackage.STRECKEN_ZUG__WEG_BISHER;
        case StreckenprofilPackage.STRECKEN_ZUG_EINTRAG__LAENGE: return StreckenprofilPackage.STRECKEN_ZUG__LAENGE;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String toString() {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (internalState: ");
    result.append(internalState);
    result.append(", wegBisher: ");
    result.append(wegBisher);
    result.append(", laenge: ");
    result.append(laenge);
    result.append(", streckenzugName: ");
    result.append(streckenzugName);
    result.append(')');
    return result.toString();
  }

} // StreckenZugImpl
