package de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein;

/**
 * Klasse zur Unterscheidung welche Parameterarten (Anlagen-, Anzeigequerschnitt oder Anzeigenspezifisch)
 * fr die einzelnen Parameterarten mglich sind. Die Arten knnen verodert werden.
 * @author ObertM
 */
public class PA
{
	/**
	 * Anlagen spezifische Parameter 
	 */
	public static final int ANLAGE = 1;

	/**
	 * Anzeigequerschnitt spezifische Parameter
	 */
	public static final int QUERSCHNITT = 1 << 1;

	/**
	 * Anzeige spezifische Parameter
	 */
	public static final int ANZEIGE = 1 << 2;

}
